#include "complex.hpp"


// dodawanie w stylu jezyka C
complex add(const complex a, const complex b)
{
	return { a.r_ + b.r_, a.i_ + b.i_ };
}

// odejmowanie w stylu jezyka C
complex substract(const complex a, const complex b)
{
	return { a.r_ - b.r_, a.i_ - b.i_ };
}

// mnozenie w stylu jezyka C
complex multiply(const complex a, const complex b)
{
	return { a.r_ * b.r_ - a.i_ * b.i_,
		a.r_ * b.i_ + a.i_ * b.r_ };
}

// dzielenie w stylu jezyka C
complex divide(const complex a, const complex b)
{
	auto mod2b = b.r_ *b.r_ + b.i_ * b.i_;
	if (0 == mod2b)
		return { 0,0 };

	return { (a.r_ * b.r_ + a.i_ * b.i_) / mod2b,  (a.i_ * b.r_ - a.r_ * b.i_) / mod2b };
}

// dodawanie w stylu jezyka C++
complex operator+(const complex& a, const complex& b)
{
	return add(a, b); // po co powtarzac kod, skoro jest juz napisany!!! 
}

// odejmowanie w stylu jezyka C++
complex operator-(const complex& a, const complex& b)
{
	return substract(a, b);
}

// mnozenie w stylu jezyka C++
complex operator*(const complex& a, const complex& b)
{
	return multiply(a, b);
}

// dodawanie w stylu jezyka C++
complex operator/(const complex& a, const complex& b)
{
	return divide(a, b);
}

// wyswietlenie liczby zespolonej jako funkcja
void print(const complex a)
{
	std::cout << a.r_; // obsluga wyswietlania w stylu C++ / wiecej mozna dowiedziec sie na wykladzie lub https://en.cppreference.com/w/cpp/io/cout
	if (a.i_ >= 0)
		std::cout << " + " << a.i_ << "j";
	else
		std::cout << " - " << -a.i_ << "j";;
}

// wyswietlanie liczby zespolonej w stylu C++ 
std::ostream& operator<<(std::ostream& os, const complex& a)
{
	os << a.r_;
	if (a.i_ >= 0)
		os << " + " << a.i_ << "j";
	else
		os << " - " << -a.i_ << "j";
	return os;
}