#ifndef SIMPLE_COMPLEX
#define SIMPLE_COMPLEX

#include <iostream> // biblioteka do obslugi standardowego wejscia wyjscia

// struktura reprezentujaca liczbe zespolona
// struktury w C++ sa de facto klasami o pewnych specyficznych wlasciwosciach / wiecej na wykladzie
struct complex
{
	double r_;
	double i_;
};

// dodawanie w stylu jezyka C
complex add(const complex a, const complex b);

// odejmowanie w stylu jezyka C
complex substract(const complex a, const complex b);

// mnozenie w stylu jezyka C
complex multiply(const complex a, const complex b);

// dzielenie w stylu jezyka C
complex divide(const complex a, const complex b);

// dodawanie w stylu jezyka C++
complex operator+(const complex& a, const complex& b);

// odejmowanie w stylu jezyka C++
complex operator-(const complex& a, const complex& b);

// mnozenie w stylu jezyka C++
complex operator*(const complex& a, const complex& b);

// dodawanie w stylu jezyka C++
complex operator/(const complex& a, const complex& b);

// wyswietlenie liczby zespolonej jako funkcja
void print(const complex a);

// wyswietlanie liczby zespolonej w stylu C++ 
std::ostream& operator<<(std::ostream& os, const complex& a);

#endif // #ifndef SIMPLE_COMPLEX