#include "math.hpp"


// operacje na liczbach zespolonych
// podniesienie liczby zespolonej do potegi bedacej liczba naturalna / uwaga : algorytm naiwny wykorzystujacy rekurencje - istnieja algorytmy znacznie bardziej efektwyne.
complex power(const complex a, unsigned int i)
{
	if (0 == i)
		return { 1,0 };
	else
		return a * power(a, i - 1);
}

int power(int a, unsigned int i)
{
	if (0 == i)
		return 1;
	else
		return a * power(a, i - 1);
}

long long factorial(long long i)
{
	if (0 == i)
		return 1;
	else
		return (factorial(i - 1)*i);
}

// obliczenie wartosci funkcji sinus arumentu zespolonego, wykorzystujac rozwiniecie w szereg Taylora. 
complex sin(const complex a)
{
	unsigned int N = 20; // ilosc branych pod uwage wyrazow szeregu Taylora

	complex r = { 0,0 }; // zwracany wynik, ktory bedzie aktualizowany

	for (unsigned int i = 0; i < N; ++i) // petla 
	{
		complex k = { double(power(-1, i)) / double(factorial(2 * i + 1)) , 0 };
		r = r + power(a, 2 * i + 1) * k;
	}
	return r;
}